diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/model/phased-array-model.h ns-3.41/src/antenna/model/phased-array-model.h
--- ns-3.40/src/antenna/model/phased-array-model.h	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/model/phased-array-model.h	2024-02-09 14:44:07.849789600 -0800
@@ -73,17 +73,7 @@
     }
 
     /**
-     * Returns the horizontal and vertical components of the antenna element field
-     * pattern at the specified direction. Single polarization is considered.
-     * \param a the angle indicating the interested direction
-     * \return a pair in which the first element is the horizontal component
-     *         of the field pattern and the second element is the vertical
-     *         component of the field pattern
-     */
-    virtual std::pair<double, double> GetElementFieldPattern(Angles a) const = 0;
-
-    /**
-     * Returns the location of the antenna element with the specified
+     * \brief Returns the location of the antenna element with the specified
      * index, normalized with respect to the wavelength.
      * \param index the index of the antenna element
      * \return the 3D vector that represents the position of the element
@@ -91,10 +81,128 @@
     virtual Vector GetElementLocation(uint64_t index) const = 0;
 
     /**
-     * Returns the number of antenna elements
+     * \brief Returns the number of antenna elements
      * \return the number of antenna elements
      */
-    virtual size_t GetNumberOfElements() const = 0;
+    virtual size_t GetNumElems() const = 0;
+
+    /**
+     * \brief Returns the horizontal and vertical components of the antenna element field
+     * pattern at the specified direction. Single polarization is considered.
+     * \param a the angle indicating the interested direction
+     * \param polIndex the index of the polarization for which will be retrieved the field
+     * pattern
+     * \return a pair in which the first element is the horizontal component of the field
+     * pattern and the second element is the vertical component of the field pattern
+     */
+    virtual std::pair<double, double> GetElementFieldPattern(Angles a,
+                                                             uint8_t polIndex = 0) const = 0;
+
+    /**
+     * \brief Set the vertical number of ports
+     * \param nPorts the vertical number of ports
+     */
+    virtual void SetNumVerticalPorts(uint16_t nPorts) = 0;
+
+    /**
+     * \brief Set the horizontal number of ports
+     * \param nPorts the horizontal number of ports
+     */
+    virtual void SetNumHorizontalPorts(uint16_t nPorts) = 0;
+
+    /**
+     * \brief Get the vertical number of ports
+     * \return the vertical number of ports
+     */
+    virtual uint16_t GetNumVerticalPorts() const = 0;
+
+    /**
+     * \brief Get the horizontal number of ports
+     * \return the horizontal number of ports
+     */
+    virtual uint16_t GetNumHorizontalPorts() const = 0;
+
+    /**
+     * \brief Get the number of ports
+     * \return the number of ports
+     */
+    virtual uint16_t GetNumPorts() const = 0;
+
+    /**
+     * \brief Get the number of polarizations
+     * \return the number of polarizations
+     */
+    virtual uint8_t GetNumPols() const = 0;
+
+    /**
+     * \brief Get the vertical number of antenna elements per port
+     * \return the vertical number of antenna elements per port
+     */
+    virtual size_t GetVElemsPerPort() const = 0;
+    /**
+     * \brief Get the horizontal number of antenna elements per port
+     * \return the horizontal number of antenna elements per port
+     */
+    virtual size_t GetHElemsPerPort() const = 0;
+
+    /**
+     * \brief Get the number of elements per port
+     * \return the number of elements per port
+     */
+    virtual size_t GetNumElemsPerPort() const = 0;
+
+    /**
+     * \brief Set the number of columns
+     * \param nColumns the number of columns to be set
+     */
+    virtual void SetNumColumns(uint32_t nColumns) = 0;
+
+    /**
+     * \brief Set the number of rows
+     * \param nRows the number of rows to be set
+     */
+    virtual void SetNumRows(uint32_t nRows) = 0;
+
+    /**
+     * \brief Get the number of columns
+     * \return the number of columns in the antenna array
+     */
+    virtual uint32_t GetNumColumns() const = 0;
+
+    /**
+     * \brief Get the number of rows
+     * \return the number of rows in the antenna array
+     */
+    virtual uint32_t GetNumRows() const = 0;
+
+    /**
+     * \brief Get the polarization slant angle
+     * \return the polarization slant angle
+     */
+    virtual double GetPolSlant() const = 0;
+
+    /**
+     * \brief Get the indication whether the antenna array is dual polarized
+     * \return Returns true if the antenna array is dual polarized
+     */
+    virtual bool IsDualPol() const = 0;
+
+    /**
+     * \brief Calculate the index in the antenna array from the port index and the element in the
+     * port
+     * \param portIndex the port index
+     * \param subElementIndex the element index in the port
+     * \return the antenna element index in the antenna array
+     */
+    virtual uint16_t ArrayIndexFromPortIndex(uint16_t portIndex,
+                                             uint16_t subElementIndex) const = 0;
+
+    /**
+     * Returns the index of the polarization to which belongs that antenna element
+     * \param elementIndex the antenna element for which will be returned the polarization index
+     * \return the polarization index
+     */
+    virtual uint8_t GetElemPol(size_t elementIndex) const = 0;
 
     /**
      * Sets the beamforming vector to be used
@@ -109,6 +217,12 @@
     ComplexVector GetBeamformingVector() const;
 
     /**
+     * Returns the const reference of the beamforming vector that is currently being used
+     * \return the const reference of the current beamforming vector
+     */
+    const PhasedArrayModel::ComplexVector& GetBeamformingVectorRef() const;
+
+    /**
      * Returns the beamforming vector that points towards the specified position
      * \param a the beamforming angle
      * \return the beamforming vector
@@ -149,15 +263,6 @@
     uint32_t m_id{0}; //!< the ID of this antenna array instance
 };
 
-/**
- * \brief Stream insertion operator.
- *
- * \param [in] os The reference to the output stream.
- * \param [in] cv A vector of complex values.
- * \returns The reference to the output stream.
- */
-std::ostream& operator<<(std::ostream& os, const PhasedArrayModel::ComplexVector& cv);
-
 } /* namespace ns3 */
 
 #endif /* PHASED_ARRAY_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/model/uniform-planar-array.cc ns-3.41/src/antenna/model/uniform-planar-array.cc
--- ns-3.40/src/antenna/model/uniform-planar-array.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/model/uniform-planar-array.cc	2024-02-09 14:44:07.849789600 -0800
@@ -84,8 +84,27 @@
             .AddAttribute("PolSlantAngle",
                           "The polarization slant angle in radians",
                           DoubleValue(0.0),
-                          MakeDoubleAccessor(&UniformPlanarArray::SetPolSlant),
-                          MakeDoubleChecker<double>(-M_PI, M_PI));
+                          MakeDoubleAccessor(&UniformPlanarArray::SetPolSlant,
+                                             &UniformPlanarArray::GetPolSlant),
+                          MakeDoubleChecker<double>(-M_PI, M_PI))
+            .AddAttribute("NumVerticalPorts",
+                          "Vertical number of ports",
+                          UintegerValue(1),
+                          MakeUintegerAccessor(&UniformPlanarArray::GetNumVerticalPorts,
+                                               &UniformPlanarArray::SetNumVerticalPorts),
+                          MakeUintegerChecker<uint32_t>())
+            .AddAttribute("NumHorizontalPorts",
+                          "Horizontal number of ports",
+                          UintegerValue(1),
+                          MakeUintegerAccessor(&UniformPlanarArray::GetNumHorizontalPorts,
+                                               &UniformPlanarArray::SetNumHorizontalPorts),
+                          MakeUintegerChecker<uint32_t>())
+            .AddAttribute("IsDualPolarized",
+                          "If true, dual polarized antenna",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&UniformPlanarArray::SetDualPol,
+                                              &UniformPlanarArray::IsDualPol),
+                          MakeBooleanChecker());
     return tid;
 }
 
@@ -143,8 +162,8 @@
 UniformPlanarArray::SetPolSlant(double polSlant)
 {
     m_polSlant = polSlant;
-    m_cosPolSlant = cos(m_polSlant);
-    m_sinPolSlant = sin(m_polSlant);
+    m_cosPolSlant[0] = cos(m_polSlant);
+    m_sinPolSlant[0] = sin(m_polSlant);
 }
 
 void
@@ -186,9 +205,10 @@
 }
 
 std::pair<double, double>
-UniformPlanarArray::GetElementFieldPattern(Angles a) const
+UniformPlanarArray::GetElementFieldPattern(Angles a, uint8_t polIndex) const
 {
     NS_LOG_FUNCTION(this << a);
+    NS_ASSERT_MSG(polIndex < GetNumPols(), "Polarization index can be 0 or 1.");
 
     // convert the theta and phi angles from GCS to LCS using eq. 7.1-7 and 7.1-8 in 3GPP TR 38.901
     // NOTE we assume a fixed slant angle of 0 degrees
@@ -208,8 +228,10 @@
     // NOTE: the slant angle (assumed to be 0) differs from the polarization slant angle
     // (m_polSlant, given by the attribute), in 3GPP TR 38.901
     double aPrimeDb = m_antennaElement->GetGainDb(aPrime);
-    double fieldThetaPrime = pow(10, aPrimeDb / 20) * m_cosPolSlant; // convert to linear magnitude
-    double fieldPhiPrime = pow(10, aPrimeDb / 20) * m_sinPolSlant;   // convert to linear magnitude
+    double fieldThetaPrime =
+        pow(10, aPrimeDb / 20) * m_cosPolSlant[polIndex]; // convert to linear magnitude
+    double fieldPhiPrime =
+        pow(10, aPrimeDb / 20) * m_sinPolSlant[polIndex]; // convert to linear magnitude
 
     // compute psi using eq. 7.1-15 in 3GPP TR 38.901, assuming that the slant
     // angle (gamma) is 0
@@ -232,13 +254,19 @@
 UniformPlanarArray::GetElementLocation(uint64_t index) const
 {
     NS_LOG_FUNCTION(this << index);
-
+    uint64_t tmpIndex = index;
+    // for dual polarization, the top half corresponds to one polarization and
+    // lower half corresponds to the other polarization
+    if (m_isDualPolarized && tmpIndex >= m_numRows * m_numColumns)
+    {
+        tmpIndex -= m_numRows * m_numColumns;
+    }
     // compute the element coordinates in the LCS
     // assume the left bottom corner is (0,0,0), and the rectangular antenna array is on the y-z
     // plane.
     double xPrime = 0;
-    double yPrime = m_disH * (index % m_numColumns);
-    double zPrime = m_disV * floor(index / m_numColumns);
+    double yPrime = m_disH * (tmpIndex % m_numColumns);
+    double zPrime = m_disV * floor(tmpIndex / m_numColumns);
 
     // convert the coordinates to the GCS using the rotation matrix 7.1-4 in 3GPP
     // TR 38.901
@@ -249,10 +277,129 @@
     return loc;
 }
 
+uint8_t
+UniformPlanarArray::GetNumPols() const
+{
+    return m_isDualPolarized ? 2 : 1;
+}
+
 size_t
-UniformPlanarArray::GetNumberOfElements() const
+UniformPlanarArray::GetNumElems() const
+{
+    // From 38.901  [M, N, P, Mg, Ng] = [m_numRows, m_numColumns, 2, 1, 1]
+    return GetNumPols() * m_numRows * m_numColumns;
+    // with dual polarization, the number of antenna elements double up
+}
+
+void
+UniformPlanarArray::SetNumVerticalPorts(uint16_t nPorts)
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(nPorts > 0, "Ports should be greater than 0");
+    NS_ASSERT_MSG(((m_numRows % nPorts) == 0),
+                  "The number of vertical ports must divide number of rows");
+    m_numVPorts = nPorts;
+}
+
+void
+UniformPlanarArray::SetNumHorizontalPorts(uint16_t nPorts)
+{
+    NS_ASSERT_MSG(nPorts > 0, "Ports should be greater than 0");
+    NS_ASSERT_MSG(((m_numColumns % nPorts) == 0),
+                  "The number of horizontal ports must divide number of columns");
+    m_numHPorts = nPorts;
+}
+
+uint16_t
+UniformPlanarArray::GetNumVerticalPorts() const
+{
+    return m_numVPorts;
+}
+
+uint16_t
+UniformPlanarArray::GetNumHorizontalPorts() const
+{
+    return m_numHPorts;
+}
+
+uint16_t
+UniformPlanarArray::GetNumPorts() const
+{
+    return GetNumPols() * m_numVPorts * m_numHPorts;
+}
+
+size_t
+UniformPlanarArray::GetVElemsPerPort() const
+{
+    return m_numRows / m_numVPorts;
+}
+
+size_t
+UniformPlanarArray::GetHElemsPerPort() const
+{
+    return m_numColumns / m_numHPorts;
+}
+
+size_t
+UniformPlanarArray::GetNumElemsPerPort() const
+{
+    // Multiply the number of rows and number of columns belonging to one antenna port.
+    // This also holds for dual polarization, where each polarization belongs to a separate port.
+    return GetVElemsPerPort() * GetHElemsPerPort();
+}
+
+uint16_t
+UniformPlanarArray::ArrayIndexFromPortIndex(uint16_t portIndex, uint16_t subElementIndex) const
+{
+    NS_ASSERT_MSG(portIndex < GetNumPorts(), "Port should be less than total Ports");
+    NS_ASSERT(subElementIndex < (GetHElemsPerPort() * GetVElemsPerPort()));
+
+    // In case the array is dual-polarized, change to the index that belongs to the first
+    // polarization
+    auto firstPolPortIdx = portIndex;
+    auto polarizationOffset = 0;
+    auto arraySize = GetNumHorizontalPorts() * GetNumVerticalPorts();
+    if (firstPolPortIdx >= arraySize)
+    {
+        firstPolPortIdx = portIndex - arraySize;
+        polarizationOffset = GetNumColumns() * GetNumRows();
+    }
+    // column-major indexing
+    auto hPortIdx = firstPolPortIdx / GetNumVerticalPorts();
+    auto vPortIdx = firstPolPortIdx % GetNumVerticalPorts();
+    auto hElemIdx = (hPortIdx * GetHElemsPerPort()) + (subElementIndex % GetHElemsPerPort());
+    auto vElemIdx = (vPortIdx * GetVElemsPerPort()) + (subElementIndex / GetHElemsPerPort());
+    return (vElemIdx * GetNumColumns() + hElemIdx + polarizationOffset);
+}
+
+bool
+UniformPlanarArray::IsDualPol() const
+{
+    return m_isDualPolarized;
+}
+
+void
+UniformPlanarArray::SetDualPol(bool isDualPol)
+{
+    m_isDualPolarized = isDualPol;
+    if (isDualPol)
+    {
+        m_cosPolSlant[1] = cos(m_polSlant - M_PI / 2);
+        m_sinPolSlant[1] = sin(m_polSlant - M_PI / 2);
+    }
+}
+
+double
+UniformPlanarArray::GetPolSlant() const
+{
+    return m_polSlant;
+}
+
+uint8_t
+UniformPlanarArray::GetElemPol(size_t elemIndex) const
 {
-    return m_numRows * m_numColumns;
+    NS_ASSERT(elemIndex < GetNumElems());
+    return (elemIndex < GetNumRows() * GetNumColumns()) ? 0 : 1;
 }
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/model/uniform-planar-array.h ns-3.41/src/antenna/model/uniform-planar-array.h
--- ns-3.40/src/antenna/model/uniform-planar-array.h	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/model/uniform-planar-array.h	2024-02-09 14:44:07.849789600 -0800
@@ -31,7 +31,7 @@
  * \brief Class implementing Uniform Planar Array (UPA) model.
  *
  * \note the current implementation supports the modeling of antenna arrays
- * composed of a single panel and with single (configured) polarization.
+ * composed of a single panel and with single or dual polarization.
  */
 class UniformPlanarArray : public PhasedArrayModel
 {
@@ -54,13 +54,15 @@
 
     /**
      * Returns the horizontal and vertical components of the antenna element field
-     * pattern at the specified direction. Single polarization is considered.
+     * pattern at the specified direction and for the specified polarization.
      * \param a the angle indicating the interested direction
+     * \param polIndex the index of the polarization for which will be retrieved the field
+     * pattern
      * \return a pair in which the first element is the horizontal component
      *         of the field pattern and the second element is the vertical
      *         component of the field pattern
      */
-    std::pair<double, double> GetElementFieldPattern(Angles a) const override;
+    std::pair<double, double> GetElementFieldPattern(Angles a, uint8_t polIndex = 0) const override;
 
     /**
      * Returns the location of the antenna element with the specified
@@ -72,32 +74,55 @@
      * |  3 4 5
      * |  0 1 2
      * ----------> y
+     * In case of dual-polarized antennas, the antennas of the first and the second polarization
+     * are overlapped in space.
      *
      * \param index index of the antenna element
-     * \return the 3D vector that represents the position of the element
+     * \return the 3D vector that
+     * represents the position of the element
      */
     Vector GetElementLocation(uint64_t index) const override;
 
     /**
-     * Returns the number of antenna elements
+     *  Check if an antenna array contains dual-polarized elements
+     *
+     * \return true if antenna has two polarization otherwise false
+     */
+    bool IsDualPol() const override;
+
+    /**
+     *  Returns polarization angle of first polarization
+     *  \return polarization angle in radians
+     */
+    double GetPolSlant() const override;
+
+    /**
+     * Returns the number of polarizations, 2 in the case that
+     * the antenna is dual-polarized, otherwise 1
+     * \return
+     */
+    uint8_t GetNumPols() const override;
+
+    /**
+     * Returns the number of total antenna elements. Note that if the antenna
+     * is dual-polarized the number of total antenna elements is doubled.
      * \return the number of antenna elements
      */
-    size_t GetNumberOfElements() const override;
+    size_t GetNumElems() const override;
 
-  private:
     /**
      * Set the number of columns of the phased array
      * This method resets the stored beamforming vector to a ComplexVector
      * of the correct size, but zero-filled
      * \param n the number of columns
      */
-    void SetNumColumns(uint32_t n);
+    void SetNumColumns(uint32_t n) override;
 
     /**
      * Get the number of columns of the phased array
      * \return the number of columns
      */
-    uint32_t GetNumColumns() const;
+    uint32_t GetNumColumns() const override;
 
     /**
      * Set the number of rows of the phased array
@@ -105,13 +130,69 @@
      * of the correct size, but zero-filled
      * \param n the number of rows
      */
-    void SetNumRows(uint32_t n);
+    void SetNumRows(uint32_t n) override;
 
     /**
      * Get the number of rows of the phased array
      * \return the number of rows
      */
-    uint32_t GetNumRows() const;
+    uint32_t GetNumRows() const override;
+
+    /**
+     * Set the number of vertical antenna ports
+     * \param nPorts The number of vertical ports to be configured
+     */
+    void SetNumVerticalPorts(uint16_t nPorts) override;
+
+    /**
+     * Set the number of horizontal antenna ports
+     * \param nPorts
+     */
+    void SetNumHorizontalPorts(uint16_t nPorts) override;
+
+    /**
+     * Get the number of vertical antenna ports
+     * \return the number of vertical antenna ports
+     */
+    uint16_t GetNumVerticalPorts() const override;
+
+    /**
+     * Get the number of horizontal antenna ports
+     * \return the number of horizontal antenna ports
+     */
+    uint16_t GetNumHorizontalPorts() const override;
+
+    /**
+     * Get the total number of antenna ports
+     * \return the number of antenna ports
+     */
+    uint16_t GetNumPorts() const override;
+
+    /**
+     * Get the number of vertical elements belonging to each port
+     * \return the number of vertical elements belonging of each port
+     */
+    size_t GetVElemsPerPort() const override;
+
+    /**
+     * Get the number of horizontal elements belonging to each port
+     * \return the number of horizontal elements belonging to each port
+     */
+    size_t GetHElemsPerPort() const override;
+
+    /**
+     * Get the total number of elements belonging to each port
+     * \return the number of elements per port
+     */
+    size_t GetNumElemsPerPort() const override;
+
+    /**
+     * Maps element within a port to an index of element within the antenna array
+     * \param portIndex the port index
+     * \param subElementIndex the element index within the port
+     * \return the element index in the antenna array
+     */
+    uint16_t ArrayIndexFromPortIndex(uint16_t portIndex, uint16_t subElementIndex) const override;
 
     /**
      * \brief Set the bearing angle
@@ -165,19 +246,37 @@
      */
     double GetAntennaVerticalSpacing() const;
 
+    /**
+     * Set the polarization
+     * \param isDualPol whether to set the antenna array to be dual-polarized,
+     * if true, antenna will be dual-polarized
+     */
+    void SetDualPol(bool isDualPol);
+
+    /**
+     * Returns the index of polarization to which belongs the antenna element with a specific index
+     * \param elemIndex the antenna element index
+     * \return the polarization index
+     */
+    uint8_t GetElemPol(size_t elemIndex) const override;
+
+  private:
     uint32_t m_numColumns{1}; //!< number of columns
     uint32_t m_numRows{1};    //!< number of rows
     double m_disV{0.5}; //!< antenna spacing in the vertical direction in multiples of wave length
     double m_disH{0.5}; //!< antenna spacing in the horizontal direction in multiples of wave length
-    double m_alpha{0.0};       //!< the bearing angle in radians
-    double m_cosAlpha{1.0};    //!< the cosine of alpha
-    double m_sinAlpha{0.0};    //!< the sine of alpha
-    double m_beta{0.0};        //!< the downtilt angle in radians
-    double m_cosBeta{1.0};     //!< the cosine of Beta
-    double m_sinBeta{0.0};     //!< the sine of Beta
-    double m_polSlant{0.0};    //!< the polarization slant angle in radians
-    double m_cosPolSlant{1.0}; //!< the cosine of polarization slant angle
-    double m_sinPolSlant{0.0}; //!< the sine polarization slant angle
+    double m_alpha{0.0};                          //!< the bearing angle in radians
+    double m_cosAlpha{1.0};                       //!< the cosine of alpha
+    double m_sinAlpha{0.0};                       //!< the sine of alpha
+    double m_beta{0.0};                           //!< the downtilt angle in radians
+    double m_cosBeta{1.0};                        //!< the cosine of Beta
+    double m_sinBeta{0.0};                        //!< the sine of Beta
+    double m_polSlant{0.0};                       //!< the polarization slant angle in radians
+    bool m_isDualPolarized{false};                //!< if true antenna elements are dual-polarized
+    uint16_t m_numVPorts{1};                      //!< Number of vertical ports
+    uint16_t m_numHPorts{1};                      //!< Number of horizontal ports
+    std::vector<double> m_cosPolSlant{1.0, 0.0};  //!< the cosine of polarization slant angle
+    std::vector<double> m_sinPolSlant{0.0, -1.0}; //!< the sine polarization slant angle
 };
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/test/test-cosine-antenna.cc ns-3.41/src/antenna/test/test-cosine-antenna.cc
--- ns-3.40/src/antenna/test/test-cosine-antenna.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/test/test-cosine-antenna.cc	2024-02-09 14:44:07.849789600 -0800
@@ -721,7 +721,7 @@
                                                -7,
                                                EQUAL),
                 TestCase::QUICK);
-};
+}
 
 /// Static variable for test initialization
 static CosineAntennaModelTestSuite g_staticCosineAntennaModelTestSuiteInstance;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/test/test-degrees-radians.cc ns-3.41/src/antenna/test/test-degrees-radians.cc
--- ns-3.40/src/antenna/test/test-degrees-radians.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/test/test-degrees-radians.cc	2024-02-09 14:44:07.849789600 -0800
@@ -155,7 +155,7 @@
     AddTestCase(new RadiansToDegreesTestCase(M_PI + M_PI, 360), TestCase::QUICK);
     AddTestCase(new RadiansToDegreesTestCase(-M_PI_2, -90), TestCase::QUICK);
     AddTestCase(new RadiansToDegreesTestCase(4.5 * M_PI, 810), TestCase::QUICK);
-};
+}
 
 /// Static variable for test initialization
 static DegreesRadiansTestSuite g_staticDegreesRadiansTestSuiteInstance;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/test/test-isotropic-antenna.cc ns-3.41/src/antenna/test/test-isotropic-antenna.cc
--- ns-3.40/src/antenna/test/test-isotropic-antenna.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/test/test-isotropic-antenna.cc	2024-02-09 14:44:07.849789600 -0800
@@ -105,7 +105,7 @@
     AddTestCase(new IsotropicAntennaModelTestCase(Angles(M_PI_2, 0), 0.0), TestCase::QUICK);
     AddTestCase(new IsotropicAntennaModelTestCase(Angles(M_PI_2, M_PI), 0.0), TestCase::QUICK);
     AddTestCase(new IsotropicAntennaModelTestCase(Angles(M_PI_2, M_PI_2), 0.0), TestCase::QUICK);
-};
+}
 
 /// Static variable for test initialization
 static IsotropicAntennaModelTestSuite g_staticIsotropicAntennaModelTestSuiteInstance;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/test/test-parabolic-antenna.cc ns-3.41/src/antenna/test/test-parabolic-antenna.cc
--- ns-3.40/src/antenna/test/test-parabolic-antenna.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/test/test-parabolic-antenna.cc	2024-02-09 14:44:07.849789600 -0800
@@ -589,7 +589,7 @@
                                           -3,
                                           EQUAL),
         TestCase::QUICK);
-};
+}
 
 /// Static variable for test initialization
 static ParabolicAntennaModelTestSuite g_staticParabolicAntennaModelTestSuiteInstance;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/test/test-uniform-planar-array.cc ns-3.41/src/antenna/test/test-uniform-planar-array.cc
--- ns-3.40/src/antenna/test/test-uniform-planar-array.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/test/test-uniform-planar-array.cc	2024-02-09 14:44:07.849789600 -0800
@@ -153,11 +153,9 @@
 {
     // compute gain
     PhasedArrayModel::ComplexVector sv = a->GetSteeringVector(m_direction);
-    NS_TEST_EXPECT_MSG_EQ(sv.GetSize(), a->GetNumberOfElements(), "steering vector of wrong size");
+    NS_TEST_EXPECT_MSG_EQ(sv.GetSize(), a->GetNumElems(), "steering vector of wrong size");
     PhasedArrayModel::ComplexVector bf = a->GetBeamformingVector(m_direction);
-    NS_TEST_EXPECT_MSG_EQ(bf.GetSize(),
-                          a->GetNumberOfElements(),
-                          "beamforming vector of wrong size");
+    NS_TEST_EXPECT_MSG_EQ(bf.GetSize(), a->GetNumElems(), "beamforming vector of wrong size");
     std::pair<double, double> fp = a->GetElementFieldPattern(m_direction);
 
     // scalar product dot (sv, bf)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/aodv/CMakeLists.txt ns-3.41/src/aodv/CMakeLists.txt
--- ns-3.40/src/aodv/CMakeLists.txt	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/aodv/CMakeLists.txt	2024-02-09 14:44:07.849789600 -0800
@@ -18,8 +18,10 @@
     model/aodv-routing-protocol.h
     model/aodv-rqueue.h
     model/aodv-rtable.h
-  LIBRARIES_TO_LINK ${libinternet}
-                    ${libwifi}
+  LIBRARIES_TO_LINK
+    ${libapplications}
+    ${libinternet-apps}
+    ${libwifi}
   TEST_SOURCES
     test/aodv-id-cache-test-suite.cc
     test/aodv-regression.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/aodv/model/aodv-packet.h ns-3.41/src/aodv/model/aodv-packet.h
--- ns-3.40/src/aodv/model/aodv-packet.h	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/aodv/model/aodv-packet.h	2024-02-09 14:44:07.849789600 -0800
@@ -485,7 +485,7 @@
      */
     void SetPrefixSize(uint8_t sz);
     /**
-     * \brief Set the pefix size
+     * \brief Set the prefix size
      * \return the prefix size
      */
     uint8_t GetPrefixSize() const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/aodv/model/aodv-routing-protocol.cc ns-3.41/src/aodv/model/aodv-routing-protocol.cc
--- ns-3.40/src/aodv/model/aodv-routing-protocol.cc	2023-09-27 13:30:37.614839000 -0700
+++ ns-3.41/src/aodv/model/aodv-routing-protocol.cc	2024-02-09 14:44:07.853789800 -0800
@@ -1379,7 +1379,7 @@
             /*iface=*/m_ipv4->GetAddress(m_ipv4->GetInterfaceForAddress(receiver), 0),
             /*hops=*/hop,
             /*nextHop=*/src,
-            /*lifetime=*/Time((2 * m_netTraversalTime - 2 * hop * m_nodeTraversalTime)));
+            /*lifetime=*/Time(2 * m_netTraversalTime - 2 * hop * m_nodeTraversalTime));
         m_routingTable.AddRoute(newEntry);
     }
     else
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/aodv/model/aodv-rqueue.cc ns-3.41/src/aodv/model/aodv-rqueue.cc
--- ns-3.40/src/aodv/model/aodv-rqueue.cc	2023-09-27 13:30:37.614839000 -0700
+++ ns-3.41/src/aodv/model/aodv-rqueue.cc	2024-02-09 14:44:07.853789800 -0800
@@ -121,14 +121,13 @@
  */
 struct IsExpired
 {
-    bool
     /**
      * Check if the entry is expired
      *
      * \param e QueueEntry entry
      * \return true if expired, false otherwise
      */
-    operator()(const QueueEntry& e) const
+    bool operator()(const QueueEntry& e) const
     {
         return (e.GetExpireTime() < Seconds(0));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/aodv/test/bug-772.cc ns-3.41/src/aodv/test/bug-772.cc
--- ns-3.40/src/aodv/test/bug-772.cc	2023-09-27 13:30:37.614839000 -0700
+++ ns-3.41/src/aodv/test/bug-772.cc	2024-02-09 14:44:07.853789800 -0800
@@ -37,7 +37,6 @@
 #include "ns3/simulator.h"
 #include "ns3/string.h"
 #include "ns3/uinteger.h"
-#include "ns3/v4ping-helper.h"
 #include "ns3/yans-wifi-helper.h"
 
 #include <sstream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/aodv/test/loopback.cc ns-3.41/src/aodv/test/loopback.cc
--- ns-3.40/src/aodv/test/loopback.cc	2023-09-27 13:30:37.614839000 -0700
+++ ns-3.41/src/aodv/test/loopback.cc	2024-02-09 14:44:07.853789800 -0800
@@ -36,7 +36,6 @@
 #include "ns3/udp-echo-helper.h"
 #include "ns3/udp-socket-factory.h"
 #include "ns3/uinteger.h"
-#include "ns3/v4ping.h"
 #include "ns3/yans-wifi-helper.h"
 
 #include <sstream>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/applications/CMakeLists.txt ns-3.41/src/applications/CMakeLists.txt
--- ns-3.40/src/applications/CMakeLists.txt	2023-09-27 13:30:37.614839000 -0700
+++ ns-3.41/src/applications/CMakeLists.txt	2024-02-09 14:44:07.853789800 -0800
@@ -49,7 +49,6 @@
     model/udp-server.h
     model/udp-trace-client.h
   LIBRARIES_TO_LINK ${libinternet}
-                    ${libstats}
   TEST_SOURCES
     test/three-gpp-http-client-server-test.cc
     test/bulk-send-application-test-suite.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/applications/helper/bulk-send-helper.h ns-3.41/src/applications/helper/bulk-send-helper.h
--- ns-3.40/src/applications/helper/bulk-send-helper.h	2023-09-27 13:30:37.614839000 -0700
+++ ns-3.41/src/applications/helper/bulk-send-helper.h	2024-02-09 14:44:07.853789800 -0800
@@ -49,7 +49,7 @@
      * \param protocol the name of the protocol to use to send traffic
      *        by the applications. This string identifies the socket
      *        factory type used to create sockets for the applications.
-     *        A typical value would be ns3::UdpSocketFactory.
+     *        A typical value would be ns3::TcpSocketFactory.
      * \param address the address of the remote node to send traffic
      *        to.
      */
